//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//----
#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     Red
#property indicator_color2     DeepSkyBlue
#property indicator_color3     LimeGreen
#property indicator_style3     STYLE_DASH
#property indicator_color4     Magenta
#property indicator_style4     STYLE_DASH
#property indicator_width1     2
#property indicator_width2     2
#property indicator_level1     0
#property indicator_level2     100
#property indicator_levelcolor DimGray


//
//
//
//
//

extern int Length = 9;
extern int mamode = MODE_LWMA;

//
//
//
//
//

double wso[];
double wro[];
double wsoMa[];
double wroMa[];
double wrk[][12];
int    center;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   SetIndexBuffer(0, wso); 
   SetIndexBuffer(1, wro);
   SetIndexBuffer(2, wsoMa); 
   SetIndexBuffer(3, wroMa);  
         if (MathMod(Length,2)==0) Length++;  center = (Length-1)/2;
   return(0);
}
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define S1 0
#define S2 1
#define S3 2
#define S4 3
#define S5 4
#define S6 5
#define R1 6
#define R2 7
#define R3 8
#define R4 9
#define R5 10
#define R6 11

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(wrk,0)!=Bars) ArrayResize(wrk,Bars);
         
   //
   //
   //
   //
   //

   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      if (r==0)
      {
         for (int k=0; k<6; k++)
         {
            wrk[r][k]   = Low[i];
            wrk[r][k+6] = High[i];
         }
         continue;
      }
      
      //
      //
      //
      //
      //
      
      int lowest  = iLowest(NULL,0,MODE_LOW,Length,i)-i;
      int highest = iHighest(NULL,0,MODE_HIGH,Length,i)-i;

         for (k=0; k<12; k++) wrk[r][k] = wrk[r-1][k];
         if (lowest==center)
         {
            wrk[r][S1] = Low[i+center];
            wrk[r][S2] = wrk[r-1][S1];
            wrk[r][S3] = wrk[r-1][S2];
            wrk[r][S4] = wrk[r-1][S3];
            wrk[r][S5] = wrk[r-1][S4];
            wrk[r][S6] = wrk[r-1][S5];
         }
         if (highest==center)
         {
            wrk[r][R1] = High[i+center];
            wrk[r][R2] = wrk[r-1][R1];
            wrk[r][R3] = wrk[r-1][R2];
            wrk[r][R4] = wrk[r-1][R3];
            wrk[r][R5] = wrk[r-1][R4];
            wrk[r][R6] = wrk[r-1][R5];
         }
         
         
      //
      //
      //
      //
      //

      wso[i] = 100*(1-(MathInt(wrk[r][S1]/Close[i])+
                       MathInt(wrk[r][S2]/Close[i])+
                       MathInt(wrk[r][S3]/Close[i])+
                       MathInt(wrk[r][S4]/Close[i])+
                       MathInt(wrk[r][S5]/Close[i])+
                       MathInt(wrk[r][S6]/Close[i]))/6.0);
      wro[i] = 100*(1-(MathInt(wrk[r][R1]/Close[i])+
                       MathInt(wrk[r][R2]/Close[i])+
                       MathInt(wrk[r][R3]/Close[i])+
                       MathInt(wrk[r][R4]/Close[i])+
                       MathInt(wrk[r][R5]/Close[i])+
                       MathInt(wrk[r][R6]/Close[i]))/6.0);
     }
     for(i=counted_bars; i>=0; i--)
     {
     wsoMa[i]=iMAOnArray(wso, 0, Length, 0, mamode, i);
     wroMa[i]=iMAOnArray(wro, 0, Length, 0, mamode, i);
     }
     
   return(0);
}

double MathInt(double number)
{
   if (number>=1.0)
         return(1);
   else  return(0);    
}